<?php
/**
 * @package Xpert Tweets
 * @version 1.0
 * @author ThemeXpert http://www.themexpert.com
 * @copyright Copyright (C) 2010 - 2012 ThemeXpert
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 *
 */

// no direct access
defined('_JEXEC') or die;

abstract class modXpertTweetsHelper
{
	public static function getTweets(&$params, $module_id)
	{
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');

		$count 	= $params->get('count','5');

		//set max and min count
		if ($count > 200) 	$count = 200;
		if ($count < 1) 	$count = 1;

		//final url

        if($params->get('show_tweet') == 'user')
        {
            $user 	= $params->get('tweet_term','themexpert');
            $url 	= "https://api.twitter.com/1/statuses/user_timeline.json?include_entities=true&include_rts=true&screen_name=$user&count=$count";

        }elseif($params->get('show_tweet') == 'search')
        {
            $query 	= $params->get('tweet_term','themexpert');
            $url    = "http://search.twitter.com/search.json?q=$query&rpp=$count";
        }

		$cache_time = $params->get('cache_time', 900);
		$cache_path = JPATH_ROOT. '/cache/mod_xperttweets/';
		$cache_file = "xt-cache$module_id.cache";
        $cache_file = md5($cache_file);
	 	$cache_full_path = $cache_path . $cache_file;

		if(JFile::exists($cache_full_path))
		{
			$diff = (time() - filectime($cache_full_path));
		}else{
			$diff = $cache_time + 1;
		}

		if($diff > $cache_time)
		{
			$buffer = modXpertTweetsHelper::curlInit($url);
			JFile::write($cache_full_path,$buffer);
		}

        $data = json_decode(JFile::read($cache_full_path));
        $items = array();
        $i = 0;

        if($params->get('show_tweet') == 'user')
        {
            if($count == 0) return;
            foreach($data as $tweet)
            {
                $obj = new stdClass;
                $obj->user = $tweet->user->name;
                $obj->profile_image = $tweet->user->profile_image_url;
                $obj->source = $tweet->source;
                $obj->time = modXpertTweetsHelper::timeago($tweet->created_at);
                $obj->text = modXpertTweetsHelper::twittify($tweet->text);

                $items[$i] = $obj;
                $i++;
            }
        }

        elseif($params->get('show_tweet') == 'search')
        {
            if($count == 0) return;
            foreach($data->results as $tweet)
            {
                $obj = new stdClass;
                $obj->user = $tweet->from_user_name;
                $obj->profile_image = $tweet->profile_image_url;
                $obj->source = $tweet->source;
                $obj->time = modXpertTweetsHelper::timeago($tweet->created_at);
                $obj->text = modXpertTweetsHelper::twittify($tweet->text);

                $items[$i] = $obj;
                $i++;
            }
        }

        return $items;
	}

    public function get_profile($params,$module_id)
    {
        if($params->get('show_tweet') == 'user')
        {
            $cache_path = JPATH_ROOT. '/cache/mod_xperttweets/';
            $cache_file = "xt-cache$module_id.cache";
            $cache_file = md5($cache_file);
            $cache_full_path = $cache_path . $cache_file;

            if(JFile::exists($cache_full_path))
            {
                $data = json_decode(JFile::read($cache_full_path));
            }
        }
        $profile = array();
        $profile['name'] = $data[0]->user->name;
        $profile['description'] = $data[0]->user->description;
        $profile['url'] = $data[0]->user->url;
        $profile['followers'] = $data[0]->user->followers_count;
        $profile['following'] = $data[0]->user->friends_count;
        $profile['image_url'] = $data[0]->user->profile_image_url;

        return $profile;
    }

	public static function curlInit($url)
	{
		//init curl
		$process = curl_init($url);
        curl_setopt($process, CURLOPT_HEADER, 0);
        curl_setopt($process, CURLOPT_TIMEOUT, 10);
        curl_setopt($process, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($process, CURLOPT_SSL_VERIFYPEER, false);
        @curl_setopt($process, CURLOPT_FOLLOWLOCATION, 1);
        @curl_setopt($process, CURLOPT_MAXREDIRS, 20);
        $data = curl_exec($process);
        curl_close($process);

        //$data = json_decode($data);

        return $data;
	}
	public static function twittify($tweet) {
		require_once 'lib/Autolink.php';

		return Twitter_Autolink::create($tweet)
  				->setNoFollow(false)
  				->addLinks();

	}

	public static function timeago($time){
		//get current timestampt
	    $b = strtotime("now"); 
	    //get timestamp when tweet created
	    $c = strtotime($time);
	    //get difference
	    $d = $b - $c;
	    //calculate different time values
	    $minute = 60;
	    $hour = $minute * 60;
	    $day = $hour * 24;
	    $week = $day * 7;
        
    	if(is_numeric($d) && $d > 0) {
	        //if less then 3 seconds
	        if($d < 3) return "right now";
	        //if less then minute
	        if($d < $minute) return floor($d) . " seconds ago";
	        //if less then 2 minutes
	        if($d < $minute * 2) return "about 1 minute ago";
	        //if less then hour
	        if($d < $hour) return floor($d / $minute) . " minutes ago";
	        //if less then 2 hours
	        if($d < $hour * 2) return "about 1 hour ago";
	        //if less then day
	        if($d < $day) return floor($d / $hour) . " hours ago";
	        //if more then day, but less then 2 days
	        if($d > $day && $d < $day * 2) return "yesterday";
	        //if less then year
	        if($d < $day * 365) return floor($d / $day) . " days ago";
	        //else return more than a year
	        return "over a year ago";
    	}
	}

     /*
    * Load Stylesheet
    *
    */
    public static function load_stylesheet(&$params){
        $app = &JApplication::getInstance('site', array(), 'J');
        $template = $app->getTemplate();
        $doc =& JFactory::getDocument();
        static $loadedBasicStyle;

        if ($loadedBasicStyle){
            return;
        }

        if (file_exists(JPATH_SITE.DS.'templates'.DS.$template.'/css/xperttweets.css')) {
           $doc->addStyleSheet(JURI::root(true).'/templates/'.$template.'/css/xperttweets.css');
        }
        else {
            $doc->addStyleSheet(JURI::root(true).'/modules/mod_xperttweets/tmpl/xperttweets.css');
        }

        $loadedBasicStyle = TRUE;

    }

}
